unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, XPMan, ImgList, ActnList, StdActns, ActnCtrls, ToolWin, ActnMan,
  ActnMenus, XPStyleActnCtrls, ComCtrls, Grids, ValEdit, ExtCtrls,
  StdCtrls, Buttons, LangueFrame, QuizzFile;

type
  TFormDico = class(TForm)
    StatusBar1: TStatusBar;
    ActionManager1: TActionManager;
    ActionMainMenuBar1: TActionMainMenuBar;
    FileOpen1: TFileOpen;
    FileSaveAs1: TFileSaveAs;
    FileExit1: TFileExit;
    FileNew: TAction;
    FileSave: TAction;
    ActionStart: TAction;
    Action5: TAction;
    Action6: TAction;
    Action7: TAction;
    WordGrid: TStringGrid;
    ImageList: TImageList;
    PrintDlg1: TPrintDlg;
    FileGet: TAction;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    EditUndo1: TEditUndo;
    EditInsert: TAction;
    EditDelete: TAction;
    EditSort: TAction;
    EditRandom: TAction;
    ModeOne2TwoSort: TAction;
    ModeTwo2OneSort: TAction;
    ModeOne2TwoRandom: TAction;
    ModeTwo2OneRandom: TAction;
    ModeRandom: TAction;
    ActionToolBar1: TActionToolBar;
    procedure Action6Execute(Sender: TObject);
    procedure ActionStartExecute(Sender: TObject);
    procedure Action7Execute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FileOpen1Accept(Sender: TObject);
    procedure ModeOne2TwoSortExecute(Sender: TObject);
    procedure ModeTwo2OneSortExecute(Sender: TObject);
    procedure ModeOne2TwoRandomExecute(Sender: TObject);
    procedure ModeTwo2OneRandomExecute(Sender: TObject);
    procedure ModeRandomExecute(Sender: TObject);
    procedure EditInsertExecute(Sender: TObject);
    procedure EditSortExecute(Sender: TObject);
    procedure FileSaveAs1Accept(Sender: TObject);
    procedure FileSaveExecute(Sender: TObject);
    procedure FileNewExecute(Sender: TObject);
    procedure FileSaveUpdate(Sender: TObject);
    procedure EditRandomExecute(Sender: TObject);
    procedure EditDeleteExecute(Sender: TObject);
    procedure EditDeleteUpdate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Action5Execute(Sender: TObject);
  private
    { Dclarations prives }
    procedure Actualiser;
    procedure Stocker;
  public
    { Dclarations publiques }
    FMode: Integer;
    FIsModified: boolean;
    FFileName: String;
    FQuizz: TQuizz;
  end;

var
  FormDico: TFormDico;

implementation

uses About, Quizz, Choice, Math, QuizOptions;

{$R *.dfm}

procedure TFormDico.Action6Execute(Sender: TObject);
begin
  FormAbout.ShowModal;
end;

procedure TFormDico.ActionStartExecute(Sender: TObject);
begin
  Stocker();
  if(FQuizz.Count > 0) then begin
    WordGrid.Visible := false;
    FormQuizz.Mode := FMode;
    FormQuizz.Quizz.Assign(FQuizz);
    FormQuizz.Initialize;
    FormQuizz.ShowModal;
    WordGrid.Visible := true;
  end;
end;

procedure TFormDico.Action7Execute(Sender: TObject);
begin
  Stocker;
  FormChoice.ComboBoxLangue1.Text := FQuizz.Langue1;
  FormChoice.ComboBoxLangue2.Text := FQuizz.Langue2;
  if (FormChoice.ShowModal = mrOk) then begin
    FQuizz.Langue1 := FormChoice.ComboBoxLangue1.Text;
    FQuizz.Langue2 := FormChoice.ComboBoxLangue2.Text;
  end;
  Actualiser;
end;

procedure TFormDico.FormResize(Sender: TObject);
var Width: Integer;
begin
  Width := WordGrid.Width;
  WordGrid.ColWidths[0] := Width div 2 - 10;
  WordGrid.ColWidths[1] := Width div 2 - 10;
end;

procedure TFormDico.FormCreate(Sender: TObject);
begin
  FQuizz := TQuizz.Create();
  FFileName := '';
  FMode := 0;
end;

procedure TFormDico.FileOpen1Accept(Sender: TObject);
begin
  FQuizz.LoadFromFile(FileOpen1.Dialog.FileName);
  FFileName := FileOpen1.Dialog.FileName;
  Actualiser;
end;

procedure TFormDico.ModeOne2TwoSortExecute(Sender: TObject);
begin
  FMode := 0;
end;

procedure TFormDico.ModeTwo2OneSortExecute(Sender: TObject);
begin
  FMode := 1;
end;

procedure TFormDico.ModeOne2TwoRandomExecute(Sender: TObject);
begin
  FMode := 2;
end;

procedure TFormDico.ModeTwo2OneRandomExecute(Sender: TObject);
begin
  FMode := 3;
end;

procedure TFormDico.ModeRandomExecute(Sender: TObject);
begin
  FMode := 4;
end;

procedure TFormDico.EditInsertExecute(Sender: TObject);
var LangueA, LangueB: String;
begin
  Stocker();
  LangueA := InputBox(
    Format('Langue %s', [FQuizz.Langue1]),
    Format('Mot dans la langue %s :', [FQuizz.Langue1]), '');
  if(LangueA = '') then Exit;
  LangueB := InputBox(
    Format('Langue %s', [FQuizz.Langue2]),
    Format('Mot dans la langue %s :', [FQuizz.Langue2]), '');
  if(LangueB = '') then Exit;

  FQuizz.Add(Format('%s=%s', [LangueA, LangueB]));
  Actualiser;
end;

procedure TFormDico.Actualiser;
var I: Integer;
begin
  WordGrid.Cells[0, 0] := FQuizz.Langue1;
  WordGrid.Cells[1, 0] := FQuizz.Langue2;

  WordGrid.RowCount := Max(FQuizz.TailleBuffer + 1, FQuizz.Count + 1);
  for I := 0 to FQuizz.Count - 1 do begin
    WordGrid.Cells[0, I + 1] := FQuizz.Names[I];
    WordGrid.Cells[1, I + 1] := FQuizz.Values[FQuizz.Names[I]];
  end;
  for I := FQuizz.Count + 1 to WordGrid.RowCount - 1 do begin
    WordGrid.Cells[0, I] := '';
    WordGrid.Cells[1, I] := '';
  end;
end;

procedure TFormDico.EditSortExecute(Sender: TObject);
begin
  Stocker();
  FQuizz.Sort;
  Actualiser;
end;

procedure TFormDico.FileSaveAs1Accept(Sender: TObject);
begin
  Stocker();
  FQuizz.SaveToFile(FileSaveAs1.Dialog.FileName);
  FFileName := FileSaveAs1.Dialog.FileName;
end;

procedure TFormDico.FileSaveExecute(Sender: TObject);
begin
  Stocker();
  FQuizz.SaveToFile(FFileName);
end;

procedure TFormDico.Stocker;
var I : Integer;
begin
  FQuizz.Clear;
  For I := 1 to WordGrid.RowCount - 1 do begin
    if(WordGrid.Cells[0, I] <> '') then begin
      FQuizz.Add(Format('%s=%s', [WordGrid.Cells[0, I], WordGrid.Cells[1, I]]))
    end;
  end;
  Actualiser();
end;

procedure TFormDico.FileNewExecute(Sender: TObject);
begin
  FQuizz.Clear;
  FFileName := '';
  Actualiser;
end;

procedure TFormDico.FileSaveUpdate(Sender: TObject);
begin
  FileSave.Enabled := FFileName <> '';
end;

procedure TFormDico.EditRandomExecute(Sender: TObject);
var I,
    Indice1,
    Indice2: Integer;
begin
  Stocker();
  Randomize;
  for I := 1 to FQuizz.Count do begin
    Indice1 := Random(FQuizz.Count);
    Indice2 := Random(FQuizz.Count);
    FQuizz.Move(Indice1, Indice2);
  end;
  Actualiser();
end;

procedure TFormDico.EditDeleteExecute(Sender: TObject);
begin
  WordGrid.Cells[0, WordGrid.Selection.Top] := '';
  WordGrid.Cells[1, WordGrid.Selection.Top] := '';
end;

procedure TFormDico.EditDeleteUpdate(Sender: TObject);
begin
  EditDelete.Enabled := WordGrid.Selection.Top > 0;
end;

procedure TFormDico.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  case MessageDlg('Voulez-vous enregistrer ?', mtConfirmation, mbYesNoCancel, 0) of
    mrYes : begin
      CanClose := true;
      FileSave.Execute;
    end;
    mrNo : begin
      CanClose := true;
    end;
    mrCancel : begin
      CanClose := false;
    end;
  end;
end;

procedure TFormDico.Action5Execute(Sender: TObject);
begin
  Stocker();
  FormOptions.EditNbrQuestion.Text :=  IntToStr(FQuizz.LongueurQuiz);
  FormOptions.EditLineVoca.Text := IntToStr(FQuizz.TailleBuffer);
  FormOptions.ShowModal;
  FQuizz.LongueurQuiz := StrToInt(FormOptions.EditNbrQuestion.Text);
  FQuizz.TailleBuffer := StrToInt(FormOptions.EditLineVoca.Text);
  Actualiser();
end;

end.
