unit Quizz;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, QuizzFile;

type
  TFormQuizz = class(TForm)
    LabelLng1: TLabel;
    TextLng1: TStaticText;
    LabelLng2: TLabel;
    EditLng2: TEdit;
    ButtonAnnuler: TButton;
    ButtonContinuer: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ButtonAnnulerClick(Sender: TObject);
    procedure ButtonContinuerClick(Sender: TObject);
    procedure EditLng2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
  private
    { Dclarations prives }
    FQuizz: TQuizz;
    FMode: Integer;
    FExistant: TStringList;
    FExistantIndex: Integer;
    FNotePlus,
    FNoteMoins : Integer;
    FIsCorrect : boolean;
    FSens: Integer;

    procedure SetQuizz(const Value: TQuizz);
    procedure SetMode(const Value: Integer);

    function SearchIndex(): Integer;
    function Correction(): Boolean;
    function Terminer(): Boolean;
  public
    { Dclarations publiques }
    procedure Initialize;
    procedure Continuer;

    property Quizz: TQuizz read FQuizz write SetQuizz;
    property Mode: Integer read FMode write SetMode;
  end;

var
  FormQuizz: TFormQuizz;

implementation

{$R *.dfm}

{ TFormQuizz }

procedure TFormQuizz.Initialize;
var I : Integer;
begin
  Randomize();
  if(Assigned(FExistant)) then
    FExistant.Clear
  else
    FExistant := TStringList.Create();
  for I := 0 to FQuizz.Count - 1 do begin
    FExistant.Add(IntToStr(I));
  end;
  FExistantIndex := -1;
  FNotePlus := 0;
  FNoteMoins := 0;

  EditLng2.Text := '';
  FIsCorrect := true;

  ButtonAnnuler.Caption := '&Annuler';
  ButtonContinuer.Enabled := true;

  Continuer;
end;

procedure TFormQuizz.SetMode(const Value: Integer);
begin
  FMode := Value;
end;

procedure TFormQuizz.SetQuizz(const Value: TQuizz);
begin
  FQuizz := Value;
end;

procedure TFormQuizz.FormCreate(Sender: TObject);
begin
  FQuizz := TQuizz.Create;
end;

(*
0 <=> Col1  -> Col2, Ordre
1 <=> Col2  -> Col1, Ordre
2 <=> Col1  -> Col2, Alatoire
3 <=> Col2  -> Col1, Alatoire
4 <=> Col1 <-> Col2, Alatoire
*)

procedure TFormQuizz.Continuer;
begin
  TextLng1.Caption := '';
//  EditLng2.Text := '';
  if((FExistantIndex >= 0) and (not Correction())) then Exit;

  case FMode of
  0 : begin
      LabelLng1.Caption := Format('Mot de la langue %s', [FQuizz.Langue1]);
      LabelLng2.Caption := Format('Mot de la langue %s', [FQuizz.Langue2]);
      Inc(FExistantIndex); FSens := 0;
      TextLng1.Caption := FQuizz.Names[FExistantIndex];
    end;
  1 : begin
      LabelLng2.Caption := Format('Mot de la langue %s', [FQuizz.Langue1]);
      LabelLng1.Caption := Format('Mot de la langue %s', [FQuizz.Langue2]);
      Inc(FExistantIndex); FSens := 1;
      TextLng1.Caption := FQuizz.Values[FQuizz.Names[FExistantIndex]];
    end;
  2 : begin
      LabelLng1.Caption := Format('Mot de la langue %s', [FQuizz.Langue1]);
      LabelLng2.Caption := Format('Mot de la langue %s', [FQuizz.Langue2]);
      FExistantIndex := SearchIndex(); FSens := 0;
      TextLng1.Caption := FQuizz.Names[FExistantIndex];
    end;
  3 : begin
      LabelLng2.Caption := Format('Mot de la langue %s', [FQuizz.Langue1]);
      LabelLng1.Caption := Format('Mot de la langue %s', [FQuizz.Langue2]);
      FExistantIndex := SearchIndex(); FSens := 1;
      TextLng1.Caption := FQuizz.Values[FQuizz.Names[FExistantIndex]];
    end;
  4 : begin
        FExistantIndex := SearchIndex();
        case Random(100) of
        0..49 : begin
              LabelLng1.Caption := Format('Mot de la langue %s', [FQuizz.Langue1]);
              LabelLng2.Caption := Format('Mot de la langue %s', [FQuizz.Langue2]);
              TextLng1.Caption := FQuizz.Names[FExistantIndex];
              FSens := 0;
          end;
        50..99 : begin
              LabelLng2.Caption := Format('Mot de la langue %s', [FQuizz.Langue1]);
              LabelLng1.Caption := Format('Mot de la langue %s', [FQuizz.Langue2]);
              TextLng1.Caption := FQuizz.Values[FQuizz.Names[FExistantIndex]];
              FSens := 1;
          end;
        end;
    end;
  end;
end;

procedure TFormQuizz.ButtonAnnulerClick(Sender: TObject);
begin
  Close;
end;

procedure TFormQuizz.ButtonContinuerClick(Sender: TObject);
begin
  Continuer;
end;

function TFormQuizz.SearchIndex: Integer;
var Rand: Integer;
begin
  Rand := Random(FExistant.Count);
  Result := StrToInt(FExistant[Rand]);
  FExistant.Delete(Rand);
end;

function TFormQuizz.Correction : Boolean;
var
  ReponseEnregistrerA,
  ReponseEnregistrerB,
  ReponseUtilisateur: String;
begin
  case FSens of
    0 :
      ReponseEnregistrerA := Trim(FQuizz.Values[FQuizz.Names[FExistantIndex]]);
    1 :
      ReponseEnregistrerA := Trim(FQuizz.Names[FExistantIndex]);
  end;
  ReponseEnregistrerB := LowerCase(ReponseEnregistrerA);
  ReponseUtilisateur := Trim(LowerCase(EditLng2.Text));
  if(ReponseEnregistrerB <> ReponseUtilisateur) then begin
    EditLng2.Text := Format('Rponse fausse (La rponse est %s)', [ReponseEnregistrerA]);
    EditLng2.Font.Style := EditLng2.Font.Style + [fsBold];
    EditLng2.Font.Color := clRed;
    Inc(FNoteMoins);
  end else begin
    EditLng2.Text := 'Rponse correcte';
    EditLng2.Font.Style := EditLng2.Font.Style + [fsBold];
    EditLng2.Font.Color := clGreen;
    Inc(FNotePlus);
  end;
  FIsCorrect := true;
  Result := not Terminer();
end;

procedure TFormQuizz.EditLng2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if(FIsCorrect) then begin
    EditLng2.Font.Style := EditLng2.Font.Style - [fsBold];
    EditLng2.Font.Color := clWindowText;
    EditLng2.Text := '';
    FIsCorrect := False;
  end;
end;

function TFormQuizz.Terminer : Boolean;
begin
  //MessageDlg(Format('%d %d %d', [FNotePlus, FNoteMoins, FQuizz.LongueurQuiz]), mtInformation, [mbOk], 0);
  if((FExistant.Count = 0) or ((FMode in [0..1]) and (FExistantIndex = FQuizz.Count - 1)) or (FNotePlus + FNoteMoins = FQuizz.LongueurQuiz)) then begin
    ButtonContinuer.Enabled := false;
    ButtonAnnuler.Caption := '&Fermer';

    MessageDlg(
      Format('Rsultat du test'#13'================'#13'Nombre de rponse bonne : %d'#13'Nombre de rponse fausse : %d'#13'Note : %d/%d',
             [FNotePlus, FNoteMoins, (20 * FNotePlus) div (FNotePlus + FNoteMoins), 20]), mtInformation, [mbOk], 0
    );
    Result := true;
  end else
    Result := false;
end;

procedure TFormQuizz.FormShow(Sender: TObject);
begin
  EditLng2.SetFocus;
end;

end.
